# Nmake macros for building Windows 32-Bit apps

!include <ntwin32.mak>

# This line allows NMAKE to work as well

all: shrmem.dll shrtest.exe init.exe

# Update the object files if necessary

shrtest.obj: shrtest.c
    $(cc) $(cflags) $(cvars) shrtest.c

init.obj: init.c
    $(cc) $(cflags) $(cvars) init.c

shrmem.obj: shrmem.c
    $(cc) -DDEVL $(cflags) $(cvars) shrmem.c

# Update the resources if necessary

shrtest2.res: shrtest.rc shrtest.h shrtest.dlg
    rc -r -fo shrtest.tmp shrtest.rc
    cvtres -$(CPU) shrtest.tmp -o shrtest2.res
    del shrtest.tmp

# Update the import library

# shrmem.lib: shrmem.obj shrmem.def
shrmem.lib: shrmem.def
    lib -machine:$(CPU)      \
    -def:shrmem.def         \
    -out:shrmem.lib

# Update the dynamic link library

shrmem.dll: shrmem.obj shrmem.lib shrmem.def 
    $(link) \
    -base:0x1C000000 \
    -dll \
    -entry:ShrMemEntry \
    -out:shrmem.dll \
    shrmem.exp shrmem.obj $(guilibs) advapi32.lib


# Update the executable file if necessary.
# If so, add the resource back in.

shrtest.exe: shrtest.obj shrmem.lib shrtest2.res shrtest.def
    $(link) $(guiflags) -out:shrtest.exe shrtest.obj shrmem.lib shrtest2.res $(guilibs)

init.exe: init.obj
    $(link) $(conflags) -out:init.exe init.obj $(guilibs) advapi32.lib


