/*
   Header file that defines the data structures and packet types used
   in sending requests from the POSIX subsystem to a WIN32 server process.

  (C) Copyright 1992 by

      John Richardson
      CompuServe 70541,672
      Internet jr@sni-usa.com

      This program may be used freely provided that this copyright is
      included in the source listings.
*/

struct Request_Header {
	unsigned char	rh_type,	/* Type of Packet */
#define RPC_REQUEST	1
#define RPC_REPLY	2
			rh_hdrsize,	/* Sizeof(Request_Header) */
			rh_pad0,
			rh_pad1;	/* Keep the structure aligned */
		long	rh_size,	/* Size of the total data sent */
			rh_chan,	/* Request ID (allows multiplexing) */
			rh_request;	/* Request code (opcode) */
			/* The data of rh_size is sent after the header */
};

/*
 List of rh_request codes for the win32srv program

 NOTE: Define things in IDL syntax, build more on DCE/MS RPC if possible.
*/

/*
   Send a NULL RPC request and return a status code of TRUE

   INT NoopRPC(void)
*/
int NoopRPC();

#define RPC_NOOP		1



/* 
   Request the WIN32SRV to run the supplied command line, wait for it to
   finish, then return the exit status.
*/
int SystemRPC(char *command_line);

#define RPC_RUN_SHELL_CMD_SYNC	2

/*
  Connect to the server
*/
void AttachToServer();

/*
  Path to the named pipes for POSIX
*/
#define NAMED_PIPE_PATH	""


